<?php

namespace CustomerManagement\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdateDealerCustomerId StructType
 * @subpackage Structs
 */
class UpdateDealerCustomerId extends AbstractStructBase
{
    /**
     * The customerId
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $customerId;
    /**
     * The dealerCustomerId
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $dealerCustomerId;
    /**
     * Constructor method for UpdateDealerCustomerId
     * @uses UpdateDealerCustomerId::setCustomerId()
     * @uses UpdateDealerCustomerId::setDealerCustomerId()
     * @param int $customerId
     * @param string $dealerCustomerId
     */
    public function __construct($customerId = null, $dealerCustomerId = null)
    {
        $this
            ->setCustomerId($customerId)
            ->setDealerCustomerId($dealerCustomerId);
    }
    /**
     * Get customerId value
     * @return int
     */
    public function getCustomerId()
    {
        return $this->customerId;
    }
    /**
     * Set customerId value
     * @param int $customerId
     * @return \CustomerManagement\StructType\UpdateDealerCustomerId
     */
    public function setCustomerId($customerId = null)
    {
        // validation for constraint: int
        if (!is_null($customerId) && !is_numeric($customerId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($customerId)), __LINE__);
        }
        $this->customerId = $customerId;
        return $this;
    }
    /**
     * Get dealerCustomerId value
     * @return string|null
     */
    public function getDealerCustomerId()
    {
        return $this->dealerCustomerId;
    }
    /**
     * Set dealerCustomerId value
     * @param string $dealerCustomerId
     * @return \CustomerManagement\StructType\UpdateDealerCustomerId
     */
    public function setDealerCustomerId($dealerCustomerId = null)
    {
        // validation for constraint: string
        if (!is_null($dealerCustomerId) && !is_string($dealerCustomerId)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($dealerCustomerId)), __LINE__);
        }
        $this->dealerCustomerId = $dealerCustomerId;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \CustomerManagement\StructType\UpdateDealerCustomerId
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
